--  ********************************************************************
--  Copyright(c) KingSoft
--  FileName    : KGlobalFunction.lua
--  Creator     : SunXun
--  Date        : 2015/03/31   11:13
--  Contact     : sunxun@kingsoft.com
--  Comment     : 
--  *********************************************************************


UPDATE_V2_ENABLE = true
local MAX_SEND_LEN = 2 * 1024
--INFO_GATHER_SERVER = "http://172.18.69.110:8700/" -- For Lan
--INFO_GATHER_SERVER = "http://205.252.235.92:8700/" -- For Net
--INFO_GATHER_SERVER = "http://123.59.11.121:8700/" -- For XiaoMi
--INFO_GATHER_SERVER = "http://127.0.0.1:8700/" 
INFO_GATHER_SERVER = "http://120.92.9.220:8700/" -- For Net

function cclog(...)
    print(string.format(...))
    local logInfo = string.format(...)
    local dateLog = "[" .. os.date() .. "] " .. logInfo
    
    C_Log(dateLog)
end

--[[function addDebugInfo(dateLog)
    local currentScene  = cc.Director:getInstance():getRunningScene()
    
    local debugInfoNode = currentScene:getChildByName("debugInfoNode")
    if not debugInfoNode then return end--print("----------> not debugInfoNode") end
    
    debugInfoNode:addDebugInfo(dateLog)
end]]

function showDebugInfo()
    print("----------> DebugInfo Init Start~")
    local currentScene  = cc.Director:getInstance():getRunningScene()
    
    local debugInfoNode = require("src/ui/common/KUIShowDebugInfoNode").create(currentScene)
    debugInfoNode:setName("debugInfoNode")
    currentScene:addChild(debugInfoNode, 990)
    
    print("----------> DebugInfo Init Ready~")
end

function delayExecute(target, func, delay)
    assert(target, debug.traceback())
    local wait = cc.DelayTime:create(delay)
    target:runAction(cc.Sequence:create(wait, cc.CallFunc:create(func)))
end

function tryShowError(msg, stackInfo)
    cclog("--------------------> Call Global Function: tryShowError Start")

    print("Error:", msg, tostring(stackInfo))

    local currentScene = cc.Director:getInstance():getRunningScene()
    
    local errorShowNode = require("src/ui/common/KUIShowErrorNode").create(currentScene)
    errorShowNode:setErrorInfo(msg, stackInfo)
    currentScene:addChild(errorShowNode, 999) -- we must see this top
    
    cclog("--------------------> Call Global Function: tryShowError Finish")
end

function showNoticeByID(noticeID, ...)
    local stringConfig = KConfig:getLine("string", noticeID)
    if not stringConfig then return end
    showNotice(stringConfig.szText,  stringConfig.szType, ...)
end

function showNotice(noticeInfo, type, ...)
    cclog("--------------------> Call Global Function showNotice Start~")
    noticeInfo = string.format(noticeInfo, ...)
    cclog("--------------------> Call Global Function showNotice Start~" .. noticeInfo)
    local currentScene = cc.Director:getInstance():getRunningScene()
    
    local showNoticeNode = require("src/ui/common/KUIShowNoticeNode").create(currentScene)
    showNoticeNode:setNoticeInfo(noticeInfo, type)
    currentScene:addChild(showNoticeNode, 999) -- we must see this top
    cclog("--------------------> Call Global Function showNotice Finish~")
end

function showConfirmation(confirmationInfo, confirmFunction, cancelFunction)
    cclog("--------------------> Call Global Function: showConfirmation Start~")

    local currentScene = cc.Director:getInstance():getRunningScene() 
       
    local showNode = currentScene:getChildByName("showConfirmationNode")
    if showNode then return end 
    
    local showConfirmationNode = require("src/ui/common/KUIShowConfirmationNode").create(currentScene)
    showConfirmationNode:setConfirmationInfo(confirmationInfo)
    showConfirmationNode:setOnTouchEvent(confirmFunction, cancelFunction)
    showConfirmationNode:setName("showConfirmationNode")
    currentScene:addChild(showConfirmationNode, 999) -- we must see this top
    cclog("--------------------> Call Global Function: showConfirmation Finish")
end

function showAnnounce(currentScene)
    cclog("--------------------> Call Global Function showAnnounce Start~")
    local showAnnounceNode = require("src/ui/common/KUIShowAnnounceNode").create(currentScene)
    currentScene:addChild(showAnnounceNode, 1000)
    cclog("--------------------> Call Global Function showAnnounceNode Finish~")
end

function getStackInfo(nLevel)
    if not nLevel then
        nLevel = 2
    end
    
    local szTrace = "Stack trackback: \n"
    while true do
        local tStackInfo = debug.getinfo(nLevel, "nSlu")
        if not tStackInfo then
            break
        end
        
        local szArgs = ""
        local nIndex = 1
        while true do
            local szKey, szValue = debug.getlocal(nLevel, nIndex)
            if not szKey then
                break
            end
            
            if szArgs ~= "" then
                szArgs = szArgs .. ", "
            end
            
            szArgs = szArgs .. szKey .. "=" .. tostring(szValue)
            nIndex = nIndex + 1
        end
           
        if tStackInfo.what == "C" then
            szTrace = szTrace .. "\t[C function] " .. tStackInfo.name or ""
        elseif tStackInfo.what == "main" then
            szTrace = szTrace .. string.format(
                "\t[%s]:%d in '%s'", 
                tStackInfo.short_src, 
                tStackInfo.currentline, 
                "main chunk"
            )
        else
            szTrace = szTrace .. string.format(
                "\t[%s]:%d in function %s", 
                tStackInfo.short_src, 
                tStackInfo.currentline, 
                tStackInfo.name or ""
            )
        end
        szTrace = szTrace .. "(" .. szArgs .. ")\n"
        
        nLevel = nLevel + 1
    end
    return szTrace
end

local resume = coroutine.resume
coroutine.resume = function (thread, ...)            
    local hCurThread = coroutine.running()

    --print("-----> thread resume", tostring(thread), tostring(hCurThread), debug.getinfo(2, "Sln").name)

    local ret = {resume(thread, ...)}
    if not ret[1] then
        tryShowError(ret[2], debug.traceback())
    end

    return unpack(ret)
end

function createThreadResumeFunc(...)
    local thread = coroutine.running()
    assert(thread, "main thread cannot call createThreadResumeFunc")

    local arg = {...}
    local argn = select("#", ...)
    local called = false
    return function (...)
        if argn > 0 then
            print(unpack(arg))
        end

        assert(not called, tostring(thread) .. " resume twice!")

        called = true
        return coroutine.resume(thread, ...)
    end
end

function random(range)
    if not range then
        return math.random()
    end

    return math.random(range[1] * 1000, range[2] * 1000) / 1000
end

local lastSendString = ""
function sendErrorMsg(szMsg, szStackInfo)
    if not (KPlayer and KPlayer.bDataReady) then return end
    if not szMsg or not szStackInfo then return end
    if lastSendString == szMsg then return end

    local replaceLeng = string.len("stack traceback:")
    szStackInfo = string.sub(szStackInfo, replaceLeng)
    szStackInfo = "\nstack" .. szStackInfo
    szStackInfo = string.sub(szStackInfo, 0, 500)
    lastSendString = szMsg
    require("src/network/KC2SProtocolManager"):recordClientErrorMsg(szMsg, szStackInfo)
end

function sendInfoGatherServer(szText)
    local nLen = string.len(szText)
    if nLen > MAX_SEND_LEN then
        szText = string.sub(szText, -MAX_SEND_LEN)
    end
    local errorReport = cc.XMLHttpRequest:new()
    errorReport.responseType = cc.XMLHTTPREQUEST_RESPONSE_STRING
    errorReport:open("POST", INFO_GATHER_SERVER)
    local function onReadyStateChange()
        if errorReport.readyState == 4 and (errorReport.status >= 200 and errorReport.status < 207) then
            print(errorReport.response)
        else
            print("errorReport.readyState is:", errorReport.readyState, "errorReport.status is: ",errorReport.status)
        end
    end
    errorReport:registerScriptHandler(onReadyStateChange)
    errorReport:send(szText)
end

function reload(moduleName)
    if package.loaded[moduleName] then
        package.loaded[moduleName] = nil
    end
    require(moduleName)
end
