--  ********************************************************************
--  Copyright(c) KingSoft
--  FileName    : main.lua
--  Creator     : SunXun
--  Date        : 2015/07/10   10:38
--  Contact     : sunxun@kingsoft.com
--  Comment     : 
--  *********************************************************************


-- CC_USE_DEPRECATED_API = true
local sz = tostring(nil)
print(sz, type(sz))
require "cocos.init"
-- Load Global Function
require "src/base/KGlobalFunction"

math.randomseed(os.time())

-- for CCLuaEngine traceback
function __G__TRACKBACK__(msg)
    cclog("----------------------------------------")
    cclog("LUA ERROR: " .. tostring(msg) .. "\n")
    local stackInfo = debug.traceback()
    cclog(stackInfo)
    cclog("----------------------------------------")

    local targetPlatform = cc.Application:getInstance():getTargetPlatform()
    if targetPlatform == cc.PLATFORM_OS_WINDOWS or
            targetPlatform == cc.PLATFORM_OS_LINUX or
            targetPlatform == cc.PLATFORM_OS_MAC or
            (KUtil and KUtil.isGuide()) then
        tryShowError(msg, stackInfo)
    end

    -- send error msg to server
    sendErrorMsg(msg, stackInfo)

    return msg
end

local function main()
    collectgarbage("collect")
    -- avoid memory leak
    collectgarbage("setpause", 100)
    collectgarbage("setstepmul", 5000)

    local director = cc.Director:getInstance()
    cc.Device:setKeepScreenOn(true)
    director:setDisplayStats(false)
    director:setAnimationInterval(1.0 / 60)
    cc.Director:getInstance():getOpenGLView():setDesignResolutionSize(1280, 720, cc.ResolutionPolicy.EXACT_FIT)

    -- cc.Director:getInstance():getScheduler():setTimeScale(0.4)
    local isAutoUpdate = false -- auto update flag
    if C_AsyncDownloadFile and UPDATE_V2_ENABLE then
        isAutoUpdate = false
        local targetPlatform = cc.Application:getInstance():getTargetPlatform()
        if targetPlatform ~= cc.PLATFORM_OS_WINDOWS and
                targetPlatform ~= cc.PLATFORM_OS_LINUX and
                targetPlatform ~= cc.PLATFORM_OS_MAC then
            isAutoUpdate = true -- close auto updte for Full Client
        end
    end

    if not isAutoUpdate then
        require "src/version"
        local gameScene = require("src/ui/login/KUILoginScene").create()
        if cc.Director:getInstance():getRunningScene() then
            cc.Director:getInstance():replaceScene(gameScene)
        else
            cc.Director:getInstance():runWithScene(gameScene)
        end
    else
        require "src/version"
        require("src/ui/login/KUILoginUpdateNode")
        addUpdateScene()
    end
end

local status, msg = xpcall(main, __G__TRACKBACK__)
if not status then
    error(msg)
end
